from network import LoRa
import socket
import time
import ubinascii

# Europe = LoRa.EU868

lora = LoRa(mode=LoRa.LORAWAN, region=LoRa.EU868)

# create an OTAA authentication parameters, change them to the provided credentials
app_eui = ubinascii.unhexlify('0000000000000000')
app_key = ubinascii.unhexlify('429A521E43C53B3FEDDDBF4446F02515')
dev_eui = ubinascii.unhexlify('70B3D57ED0048F82')

# join a network using OTAA (Over the Air Activation)
lora.join(activation=LoRa.OTAA, auth=(dev_eui, app_eui, app_key), timeout=0,dr=5)

# wait until the module has joined the network
while not lora.has_joined():
    time.sleep(2.5)
    print('Not yet joined...')
print('Joined')
# create a LoRa socket
s = socket.socket(socket.AF_LORA, socket.SOCK_RAW)

# set the LoRaWAN data rate
s.setsockopt(socket.SOL_LORA, socket.SO_DR, 5)

# make the socket blocking
# (waits for the data to be sent and for the 2 receive windows to expire)
s.setblocking(True)

n=0
while True:
# send some data
    s.send(bytes([0x01, 0x02, 0x03]))
    n+=1
    print('send :',n)
    time.sleep(20)

