# LoPy4 - COMMUNICATION LORA

########## Importation des bibliothèques nécessaires #######
from network import LoRa
import socket
import time
import ubinascii
from bmp180 import *
from machine import I2C, Pin            # create an I2C bus object accordingly to the port you are using

#################### Déclarations BMP180 ###################
bus = I2C(1, baudrate=100000)           # on pyboard
bmp180 = BMP180(bus)
bmp180.oversample_sett = 2
bmp180.baseline = 101325

#################### Reglages LoraWan ######################
# Europe = LoRa.EU868
lora = LoRa(mode=LoRa.LORAWAN, region=LoRa.EU868)
# create an OTAA authentication parameters, change them to the provided credentials
app_eui = ubinascii.unhexlify('0000000000000000')
app_key = ubinascii.unhexlify('96D12C7E476FC33A1AF462C6DA05ED58')
dev_eui = ubinascii.unhexlify('70B3D57ED0048738')
# join a network using OTAA (Over the Air Activation)
lora.join(activation=LoRa.OTAA, auth=(dev_eui, app_eui, app_key), timeout=0,dr=5)
# wait until the module has joined the network
while not lora.has_joined():
    time.sleep(2.5)
    print('Not yet joined...')
print('Joined')
# create a LoRa socket
s = socket.socket(socket.AF_LORA, socket.SOCK_RAW)
# set the LoRaWAN data rate
s.setsockopt(socket.SOL_LORA, socket.SO_DR, 5)
# make the socket blocking
# (waits for the data to be sent and for the 2 receive windows to expire)
s.setblocking(True)
################## Fin réglages LoraWan #################


################## Programme principal ##################
while True:
        temp = bmp180.temperature
        p = bmp180.pressure
        altitude = bmp180.altitude
        print("Temperature: ",temp)
        print("Pressure: ",p)
        print("Altitude: ",altitude)
 
        #time.sleep(30) # Break of 300sec before the next run of your program
        s.send(bytes([int(temp//1),int((temp%1)*10)]))             # Send the data en numérique (unités et diziéme)
        time.sleep(30) # Break of 300sec before the next run of your program
#pycom.heartbeat(False)
