from network import LoRa
import socket
import binascii
import struct
#import pycom
import time
from machine import Pin
#from machine import enable_irq, disable_irq
from machine import I2C
from bmp280 import *

################ Déclarations BMP280
bus = I2C()
bmp = BMP280(bus)
bmp.use_case(BMP280_CASE_WEATHER)
bmp.oversample(BMP280_OS_HIGH)
bmp.power_mode = BMP280_POWER_NORMAL


#################### Define LoraWan ########################
# for EU868
LORA_FREQUENCY = 868100000
LORA_GW_DR = "SF7BW125" #DR_5
LORA_NODE_DR = 5

# initialize LoRa in LORAWAN mode.
# Please pick the region that matches where you are using the device:
# Asia = LoRa.AS923
# Australia = LoRa.AU915
# Europe = LoRa.EU868
# United States = LoRa.US915
lora = LoRa(mode=LoRa.LORAWAN, region=LoRa.EU868)
# create an OTA authentication params
dev_eui = binascii.unhexlify('00DA1F96E46A5CD7')
app_eui = binascii.unhexlify('70B3D57ED0033D5A')
app_key = binascii.unhexlify('A86F40D43013F2A3A274D8146AB63F29')
# set the 3 default channels to the same frequency (must be before sending the OTAA join request)
lora.add_channel(0, frequency=LORA_FREQUENCY, dr_min=0, dr_max=5)
lora.add_channel(1, frequency=LORA_FREQUENCY, dr_min=0, dr_max=5)
lora.add_channel(2, frequency=LORA_FREQUENCY, dr_min=0, dr_max=5)
# join a network using OTAA
lora.join(activation=LoRa.OTAA, auth=(dev_eui, app_eui, app_key), timeout=0,
dr=LORA_NODE_DR)
# wait until the module has joined the network
while not lora.has_joined():
    time.sleep(5)
    print('Not joined yet...')
print("Joined")
# remove all the non-default channels
for i in range(3, 16):
    lora.remove_channel(i)
# create a LoRa socket
s = socket.socket(socket.AF_LORA, socket.SOCK_RAW)
# set the LoRaWAN data rate
s.setsockopt(socket.SOL_LORA, socket.SO_DR, LORA_NODE_DR)
# make the socket blocking
s.setblocking(True)
time.sleep(5.0)

#################### End of define LoraWan ###########



#################### Main program #################
def go_BMP():

    while True:
        temp = bmp.temperature
        p = bmp.pressure
       # altitude = bmp.altitude
        print(temp, p)
        print(type(temp))
         
        pkt = str(temp)
        pkh = str(p)
        testpkall = pkt+pkh # Concatenate the 2 data encoded
        s.send(testpkall)              # Send the data
        time.sleep(30) # Break of 300sec before the next run of your program
        #s.send(bytes([int(temp//1),int((temp%1)*10)]))             # Send the data en numérique
        #time.sleep(30) # Break of 300sec before the next run of your program
#pycom.heartbeat(False)

go_BMP()
#################### End of Main program ################# 